Package org.eclipse.emf.spi.cdo

# Class DefaultCDOMerger

java.lang.Object
org.eclipse.emf.spi.cdo.DefaultCDOMerger

All Implemented Interfaces:
  `CDOMerger`

Direct Known Subclasses:
  `DefaultCDOMerger.PerFeature`

public class DefaultCDOMerger extends Object implements CDOMerger
If the meaning of this type isn't clear, there really should be more of a description here...

Since:
  3.0
Author:
  Eike Stepper

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`DefaultCDOMerger.ChangedInSourceAndDetachedInTargetConflict`
If the meaning of this type isn't clear, there really should be more of a description here...
`static class`
`DefaultCDOMerger.ChangedInSourceAndTargetConflict`
If the meaning of this type isn't clear, there really should be more of a description here...
`static class`
`DefaultCDOMerger.ChangedInTargetAndDetachedInSourceConflict`
If the meaning of this type isn't clear, there really should be more of a description here...
`static class`
`DefaultCDOMerger.Conflict`
If the meaning of this type isn't clear, there really should be more of a description here...
`static class`
`DefaultCDOMerger.PerFeature`
If the meaning of this type isn't clear, there really should be more of a description here...
`static enum`
`DefaultCDOMerger.ResolutionPreference`
Enumerates the possible resolution preferences that can be used with a `DefaultCDOMerger`.

## Nested classes/interfaces inherited from interface org.eclipse.emf.cdo.transaction.CDOMerger

`CDOMerger.ConflictException`

## Constructor Summary

Constructors
Constructor
Description
`DefaultCDOMerger()`
`DefaultCDOMerger(CDOCommonRepository.ListOrdering listOrdering)`
`DefaultCDOMerger(DefaultCDOMerger.ResolutionPreference resolutionPreference)`
`DefaultCDOMerger(DefaultCDOMerger.ResolutionPreference resolutionPreference, CDOCommonRepository.ListOrdering listOrdering)`

## Method Summary

Modifier and Type
Method
Description
`protected Object`
`addedInSource(CDORevision revision)`
`protected Object`
`addedInSourceAndTarget(CDORevision targetRevision, CDORevision sourceRevision)`
`protected Object`
`addedInTarget(CDORevision revision)`
`protected Object`
`changedInSource(CDORevisionDelta delta)`
`protected Object`
`changedInSourceAndDetachedInTarget(CDORevisionDelta sourceDelta)`
`protected Object`
`changedInSourceAndTarget(CDORevisionDelta targetDelta, CDORevisionDelta sourceDelta)`
`protected Object`
`changedInTarget(CDORevisionDelta delta)`
`protected Object`
`changedInTargetAndDetachedInSource(CDORevisionDelta targetDelta)`
`protected Object`
`detachedInSource(CDOID id)`
`protected Object`
`detachedInSourceAndTarget(CDOID id)`
`protected Object`
`detachedInTarget(CDOID id)`
`Map<CDOID,DefaultCDOMerger.Conflict>`
`getConflicts()`
`CDOCommonRepository.ListOrdering`
`getListOrdering()`
`final DefaultCDOMerger.ResolutionPreference`
`getResolutionPreference()`
`CDOChangeSetData`
`getResult()`
`protected Map<CDOID,Object>`
`getSourceMap()`
`protected Map<CDOID,Object>`
`getTargetMap()`
`protected boolean`
`merge(Object targetData, Object sourceData)`
`CDOChangeSetData`
`merge(CDOChangeSet target, CDOChangeSet source)`
Calculates the changes between a source `change set` and a target `change set` and returns the result relative to their common ancestor.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### DefaultCDOMerger

public DefaultCDOMerger()

### DefaultCDOMerger

public DefaultCDOMerger(CDOCommonRepository.ListOrdering listOrdering)

Since:
  4.6

### DefaultCDOMerger

public DefaultCDOMerger(DefaultCDOMerger.ResolutionPreference resolutionPreference)

Since:
  4.2

### DefaultCDOMerger

public DefaultCDOMerger(DefaultCDOMerger.ResolutionPreference resolutionPreference, CDOCommonRepository.ListOrdering listOrdering)

Since:
  4.6

## Method Details

### getResolutionPreference

public final DefaultCDOMerger.ResolutionPreference getResolutionPreference()

Since:
  4.2

### getListOrdering

public CDOCommonRepository.ListOrdering getListOrdering()

Since:
  4.6

### getResult

public CDOChangeSetData getResult()

### getConflicts

public Map<CDOID,DefaultCDOMerger.Conflict> getConflicts()

### merge

public CDOChangeSetData merge(CDOChangeSet target, CDOChangeSet source) throws CDOMerger.ConflictException
Description copied from interface: `CDOMerger`
Calculates the changes between a source `change set` and a target `change set` and returns the result relative to their common ancestor.

Specified by:
  `merge` in interface `CDOMerger`
Throws:
  `CDOMerger.ConflictException`

### merge

protected boolean merge(Object targetData, Object sourceData)

### addedInTarget

protected Object addedInTarget(CDORevision revision)

### addedInSource

protected Object addedInSource(CDORevision revision)

### addedInSourceAndTarget

protected Object addedInSourceAndTarget(CDORevision targetRevision, CDORevision sourceRevision)

### changedInTarget

protected Object changedInTarget(CDORevisionDelta delta)

### detachedInTarget

protected Object detachedInTarget(CDOID id)

### changedInSource

protected Object changedInSource(CDORevisionDelta delta)

### detachedInSource

protected Object detachedInSource(CDOID id)

### detachedInSourceAndTarget

protected Object detachedInSourceAndTarget(CDOID id)

### changedInSourceAndTarget

protected Object changedInSourceAndTarget(CDORevisionDelta targetDelta, CDORevisionDelta sourceDelta)

### changedInSourceAndDetachedInTarget

protected Object changedInSourceAndDetachedInTarget(CDORevisionDelta sourceDelta)

### changedInTargetAndDetachedInSource

protected Object changedInTargetAndDetachedInSource(CDORevisionDelta targetDelta)

### getTargetMap

protected Map<CDOID,Object> getTargetMap()

### getSourceMap

protected Map<CDOID,Object> getSourceMap()